# #source http://12244.wpc.azureedge.net/0010-r8152.53-2.10.0.tar.bz2 outofdate
# source https://github.com/wget/realtek-r8152-linux/archive/v2.13.20200712.tar.gz
# credits goes to aur

%global		module r8152

Name:		dkms-%{module}
Version:	2.13
Release:	%mkrel 2
Source0:	%{module}-%{version}.tar.xz
# patch is now included on source
#Patch0:		r8152-k4.20.0-add-guard-fix.patch
Patch1:		r8152-2.12-makefile.patch
License:	GPLv2
Group:		System/Kernel and hardware
URL:		http://www.realtek.com.tw/
Summary:	dkms package for %{module} driver
Requires(post,preun): dkms
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Obsoletes:	%{name} <= %{version}

%description
A kernel module for Realtek RTL8152/RTL8153 Based USB Ethernet Adapters,
with S5 WOL enabled
/* table of devices that work with this driver */
/* Realtek */
	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8050)},
	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8152)},
	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8153)},
	{REALTEK_USB_DEVICE(VENDOR_ID_REALTEK, 0x8156)},
/* Microsoft */
	{REALTEK_USB_DEVICE(VENDOR_ID_MICROSOFT, 0x07ab)},
	{REALTEK_USB_DEVICE(VENDOR_ID_MICROSOFT, 0x07c6)},
/* Samsung */
	{REALTEK_USB_DEVICE(VENDOR_ID_SAMSUNG, 0xa101)},
/* Lenovo */
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x304f)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3052)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3054)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3057)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3062)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3069)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x3082)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x7205)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x720a)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x720b)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x720c)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x7214)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0x721e)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0xa359)},
	{REALTEK_USB_DEVICE(VENDOR_ID_LENOVO, 0xa387)},
/* TP-LINK */
	{REALTEK_USB_DEVICE(VENDOR_ID_TPLINK, 0x0601)},
/* Nvidia */
	{REALTEK_USB_DEVICE(VENDOR_ID_NVIDIA,  0x09ff)},

%prep
%setup -qn %{module}-%{version}
find -type f -exec chmod 0644 {} \;

%apply_patches

%install
%__rm -rf %{buildroot}
%__mkdir -p %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}
%__cp -a ./{,50-usb-realtek-net.rules,Makefile,compatibility.h,r8152.c,ReadMe.txt} %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}

cat <<EOF > %{buildroot}%{_usrsrc}/%{module}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{module}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="\$PACKAGE_NAME"
BUILT_MODULE_LOCATION[0]="./"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/r8152-53"
MAKE[0]="'make' EXTRA_CFLAGS='-DCONFIG_R8152_NAPI -DCONFIG_R8152_VLAN -DRTL8152_S5_WOL' SKIP_STACK_VALIDATION=1 all"
CLEAN="make clean"
AUTOINSTALL="yes"
EOF
###make -C $kernel_source_dir SUBDIRS=$dkms_tree/$module/$module_version/build/src EXTRA_CFLAGS='-DCONFIG_R8152_NAPI -DCONFIG_R8152_VLAN' modules
%clean
%__rm -rf %{buildroot}

%post -n dkms-%{module}
#/sbin/rmmod r8168 > /dev/null 2>&1

/usr/sbin/dkms --rpm_safe_upgrade add -m %{module} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{module} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{module} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/modprobe r8152 > /dev/null 2>&1
/sbin/service network reload > /dev/null 2>&1
echo "Reloading network configuration ... "
echo "r8152" >> /etc/modprobe.preload
fi

%preun -n dkms-%{module}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{module} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod r8152 > /dev/null 2>&1
/sbin/service network reload > /dev/null 2>&1
echo "Reloading network configuration ... "
sed -i '/r8152/ d' /etc/modprobe.preload
fi

#%postun
#rm -rf /lib/modules/*/kernel/3rdparty/r8152-53 >/dev/null 2>&1

%files
%defattr(-,root,root)
%doc ReadMe.txt
%{_usrsrc}/%{module}-%{version}-%{release}

%changelog
* Wed Sep 02 2020 onkelho <oh.quait at gmail.com> - 2.13-2pclos2020
- version update
- v2.13.20200712.tar.gz

* Wed May 20 2020 onkelho <oh.quait at gmail.com> - 2.13-1pclos2020
- new version release

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 2.12-2pclos2020
- 
* Tue Jul 16 2019 onkelho <oh.quait at gmail.com> - 2.12-1pclos2019
- new version 

* Tue Jan 15 2019 onkelho <oh.quait at gmail.com> - 2.11-1pclos2019
- new version

* Sat Oct 13 2018 onkelho <oh.quait at gmail.com> - 2.10.0-18pclos2018
- rebuild -- build as x86_64

* Thu Jul 12 2018 onkelho <oh.quait at gmail.com> - 2.10.0-17pclos2018
- rebuild

* Sat Jun 16 2018 onkelho <oh.quait at gmail.com> 2.10.0-16pclos2018
- rebuild

* Tue May 29 2018 onkelho <oh.quait at gmail.com> 2.10.0-15pclos2017
- -move modestdir to /3rdparty to prevent error in remove package
- - remove backupoption in make
- no linksys more

* Fri May 18 2018 onkelho <oh.quait at gmail.com> 2.10.0-10pclos2017
- rebuild after testing install and uninstall and backup
- rebuild, by update kernel module was builded but not installed
- edit Makefile ifneq ($(KERNELRELEASE),)
- edit Makefile
- adjustment backup

* Wed May 16 2018 onkelho <oh.quait at gmail.com> 2.10.0-1pclos2017 
- change to new update-version 0010-r8152.53-2.10.0

* Thu Sep 05 2017 onkelho <oh.quait at gmail.com> 2.09.0-1pclos2017 
- initial build
- released by realtek on 2017/8/30

